package de.iflow.flashlight;

import de.iflow.components.IFlowUser;
import de.iflow.flashlight.messages.ReqTurnOff;
import de.iflow.flashlight.messages.ReqTurnOn;
import de.iflow.flashlight.messages.TurnOff;
import de.iflow.flashlight.messages.TurnOn;
import de.iflow.views.IFlowConfirmFragment;
import de.iflow.views.IFlowConfirmFragment.ConfirmListener;

public class User extends IFlowUser {

	private static User instance;

	public static User getInstance() {
		if (instance == null) {
			instance = new User();
		}
		return instance;
	}

	public void confirmTurnOn(ReqTurnOn message) {
		IFlowConfirmFragment f = showConfirmFragment(Flashlight.getInstance(),
			"Press Ok to turn on the Flashlight?");
		f.setConfirmListener(confirmListenerForConfirmTurnOn);
		f.simulateUserInteraction();
	}

	private ConfirmListener confirmListenerForConfirmTurnOn = new ConfirmListener() {

		@Override
		public void onConfirm() {
			Flashlight.getInstance().turnOn(new TurnOn());
		}
	};
	
	public void confirmTurnOff(ReqTurnOff message) {
		IFlowConfirmFragment f = showConfirmFragment(Flashlight.getInstance(),
			"Press Ok to turn off the Flashlight?");
		f.setConfirmListener(confirmListenerForConfirmTurnOff);
		f.simulateUserInteraction();
	}

	private ConfirmListener confirmListenerForConfirmTurnOff = new ConfirmListener() {

		@Override
		public void onConfirm() {
			Flashlight.getInstance().turnOff(new TurnOff());
		}
	};

}
